﻿using System;
using System.Collections.Generic;

namespace UrlRewriting
{
    public class Products : List<Product>
    {
        private Products()
        {
        }

        public static Products GetProducts()
        {
            Products products = new Products();

            products.Add(new Product(1, "CodeBreeze", "codebreeze", "THE code-generation productivity tool.", 499.00M));
            products.Add(new Product(2, "WebControlsEx", "webcontrolsex", "A web control development framework and library.", 29.00M));
            products.Add(new Product(3, "SteelBlue Provider Suite", "providersuite", "An alternative to the stock ASP.NET security providers.", 39.00M));
            products.Add(new Product(4, "sbGallery", "sbgallery", "A full-featured web control suite for adding photo galleries to your web site.", 59.00M));
            products.Add(new Product(5, "Hydra", "hydra", "A WCF-based component suite for adding peer-to-peer communication to your desktop apps and centralized application control.", 199.00M));

            return products;
        }

        public static Product GetProduct(int productID)
        {
            Products products = Products.GetProducts();
            return products.FindByID(productID);
        }

        public Product FindByID(int productID)
        {
            Product found = null;
            foreach (Product item in this)
            {
                if(item.ProductID == productID)
                {
                    found = item;
                    break;
                }
            }
            return found;
        }

        public Product FindBySummaryCode(string summaryCode)
        {
            Product found = null;
            foreach (Product item in this)
            {
                if (item.SummaryCode == summaryCode)
                {
                    found = item;
                    break;
                }
            }
            return found;
        }

    }
}
