﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;

namespace UrlRewriting
{
    public class RegExRewriter : IRewriter 
    {
        string IRewriter.RewriteUrl(string currentUrl)
        {
            string returnUrl = string.Empty;

            NameValueCollection rulesSection =
                ConfigurationManager.GetSection("rewritingEngine") as NameValueCollection;

            foreach (string key in rulesSection)
            {
                string pattern = Utils.ResolveUrl(key);
                string mappedUrl = rulesSection[key];

                Regex expression = new Regex(pattern, RegexOptions.IgnoreCase);

                if (expression.IsMatch(currentUrl))
                {
                    returnUrl = expression.Replace(currentUrl, mappedUrl);
                    break;
                }
            }

            return returnUrl;
        }
    }
}
