﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

namespace UrlRewriting
{
    public class UrlModule : IHttpModule 
    {
        void IHttpModule.Dispose()
        {
        }

        void IHttpModule.Init(HttpApplication context)
        {
            context.BeginRequest += OnBeginRequest;
        }

        void OnBeginRequest(object sender, EventArgs e)
        {
            string rewritePath = string.Empty;
            HttpContext context = HttpContext.Current;
            string currentUrl = context.Request.Path.ToLower();
            string processPath = currentUrl.Substring(context.Request.ApplicationPath.Length).TrimStart('/').ToLower();
            string physicalPath = context.Server.MapPath(currentUrl.Substring(currentUrl.LastIndexOf('/') + 1));

            if (!System.IO.File.Exists(physicalPath))
            {
                if (processPath.EndsWith(".aspx"))
                {
                    string[] arrPath = processPath.Split('/');

                    switch (arrPath[0].ToLower())
                    {
                        case "products":

                            string[] arrPage = arrPath[1].Split('.');

                            if (arrPage[0].ToLower() != "default")
                            {
                                string summaryCode = arrPage[0].ToLower();

                                UrlRewriting.Products products = UrlRewriting.Products.GetProducts();
                                UrlRewriting.Product product = products.FindBySummaryCode(summaryCode);

                                if(product != null)
                                    rewritePath = "~/Products/ProductInformation.aspx?product_id=" + product.ProductID.ToString();
                            }

                            break;
                    }
                }
            }

            if (rewritePath != "")
                context.RewritePath(rewritePath);

        }
    }
}
