﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Text;
using System.Web;

namespace UrlRewriting
{
    public class UrlRewritingEngine : IHttpModule 
    {
        void IHttpModule.Dispose()
        {
        }

        void IHttpModule.Init(HttpApplication context)
        {
            context.BeginRequest += OnBeginRequest;
        }

        void OnBeginRequest(object sender, EventArgs e)
        {
            string rewritePath = string.Empty;
            HttpContext context = HttpContext.Current;
            string currentUrl = context.Request.Path.ToLower();
            string physicalPath = context.Server.MapPath(currentUrl.Substring(currentUrl.LastIndexOf('/') + 1));

            if (!System.IO.File.Exists(physicalPath))
            {
                if (currentUrl.EndsWith(".aspx"))
                {
                    NameValueCollection rewriters =
                        ConfigurationManager.GetSection("urlRewriters") as NameValueCollection;
                    foreach (string key in rewriters)
                    {
                        if(rewritePath == "")
                        {
                            string rewriterType = rewriters[key];
                            object module = Activator.CreateInstance(Type.GetType(rewriterType));
                            IRewriter urlModule = module as IRewriter;

                            rewritePath = urlModule.RewriteUrl(currentUrl);
                        }                        
                    }
                }
            }

            if (rewritePath != "")
                context.RewritePath(rewritePath);

        }
    }
}
